
create schema "wrapup";
CREATE EXTENSION IF NOT EXISTS pgcrypto;

CREATE TABLE "wrapup"."awards" ("id" uuid NOT NULL DEFAULT gen_random_uuid(), "type" text NOT NULL, "img" text, "img_dark" text, "event_id" uuid, "team_id" uuid, "user_id" uuid NOT NULL, "created" timestamptz NOT NULL DEFAULT now(), PRIMARY KEY ("id") , FOREIGN KEY ("team_id") REFERENCES "public"."teams"("id") ON UPDATE cascade ON DELETE restrict, FOREIGN KEY ("event_id") REFERENCES "public"."events"("id") ON UPDATE cascade ON DELETE restrict);
CREATE TABLE "wrapup"."feedback" ("id" uuid NOT NULL DEFAULT gen_random_uuid(), "source" text NOT NULL, "group" text NOT NULL, "prompt" text NOT NULL, "answer" text NOT NULL, "meta" jsonb, "team_id" uuid NOT NULL, "event_id" uuid NOT NULL, "author_id" uuid NOT NULL, "created" timestamptz NOT NULL DEFAULT now(), PRIMARY KEY ("id") , FOREIGN KEY ("team_id") REFERENCES "public"."teams"("id") ON UPDATE cascade ON DELETE restrict, FOREIGN KEY ("event_id") REFERENCES "public"."events"("id") ON UPDATE cascade ON DELETE restrict);
CREATE TABLE "wrapup"."snapshots" ("id" uuid NOT NULL DEFAULT gen_random_uuid(), "time" timestamptz NOT NULL, "total_score" float4 NOT NULL, "services_score" float4 NOT NULL, "ctf_score" float4 NOT NULL, "ctf_challenge_count" integer NOT NULL, "ctf_challenge_available" integer NOT NULL, "max_total_score" float4 NOT NULL, "max_service_score" float4 NOT NULL, "max_ctf_score" float4 NOT NULL, "team_id" uuid NOT NULL, "event_id" uuid NOT NULL, PRIMARY KEY ("id") , FOREIGN KEY ("team_id") REFERENCES "public"."teams"("id") ON UPDATE cascade ON DELETE restrict, FOREIGN KEY ("event_id") REFERENCES "public"."events"("id") ON UPDATE cascade ON DELETE restrict);
CREATE TABLE "wrapup"."snapshots_bonus" ("snapshot_id" uuid NOT NULL, "category" text NOT NULL, "score" float4 NOT NULL, PRIMARY KEY ("snapshot_id") , FOREIGN KEY ("snapshot_id") REFERENCES "wrapup"."snapshots"("id") ON UPDATE cascade ON DELETE restrict);
CREATE TABLE "wrapup"."snapshots_service" ("snapshot_id" uuid NOT NULL, "max_score" float4 NOT NULL, "score" float4 NOT NULL, "max_checks" integer NOT NULL, "accrued_checks" integer NOT NULL, "status" text NOT NULL, "check_id" uuid NOT NULL, "team_id" uuid NOT NULL, "event_id" uuid NOT NULL, PRIMARY KEY ("snapshot_id") , FOREIGN KEY ("check_id") REFERENCES "checks"."checks"("id") ON UPDATE cascade ON DELETE restrict, FOREIGN KEY ("team_id") REFERENCES "public"."teams"("id") ON UPDATE cascade ON DELETE restrict, FOREIGN KEY ("event_id") REFERENCES "public"."events"("id") ON UPDATE cascade ON DELETE restrict, FOREIGN KEY ("snapshot_id") REFERENCES "wrapup"."snapshots"("id") ON UPDATE cascade ON DELETE cascade);
